



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【xsy1214】 异或路径(xorpath) 点分治+可持久化trie</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【xsy1214】 异或路径(xorpath) 点分治+可持久化trie</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-20 02:29:23 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目大意：给你一棵$n$个点的树，每个点有一个点权$x$，问你所有路径中点权异或和最大的路径的异或和</p>
<p>数据范围：$n&le;30000$，$x&le;2^{31}-1$。</p>
<p>如果是边上有点权的话非常简单，直接一个$trie$就可以水过去了。</p>
<p>然而这题是点权，非常烦人。我们考虑用点分治去解决。</p>
<p>假设当前需要遍历的树的重心是$x$，我们开一个可持久化$trie$，我们用$son[x][i]$表示$x$的第$i$个儿子（我们假设总共有$p_x$个），将从$son[x][i]$出发的路径异或和加入第$[i,p_x]$个$trie$树中，当我们遍历出一条从$x$出发，经过$son[x][i]$的路径时，我们把这个路径的异或和放入第$i-1$个$trie$树中进行搜索。</p>
<p>我们已知点分治的时间复杂度是$O(n\ log\ n)$，由于这里面套了一个可持久化$trie$，那么时间复杂度就是$O(n\ log\ n\ log_2^{max{x}}$。</p>
<p>然后我的$trie$树出了锅，路径长度的最后一个二进制位没有被塞进$trie$中，然后成功$GG$</p>
<div>
<pre class="prettyprint linenums"> #include&lt;bits/stdc++.h&gt;<br />
 #define M 100005<br />
 #define INF 19260817<br />
 using namespace std;

 struct edge{int u,next;}e[M*]={}; int head[M]={},Use=;<br />
 void add(int x,int y){Use++;e[Use].u=y;e[Use].next=head[x];head[x]=Use;}

 int num[M]={},vis[M]={};

 int siz[M]={};

 void dfssiz(int x,int fa){<br />
     siz[x]=;<br />
     for(int i=head[x];i;i=e[i].next)<br />
     if(e[i].u!=fa&amp;&amp;vis[e[i].u]==){<br />
         dfssiz(e[i].u,x);<br />
         siz[x]+=siz[e[i].u];<br />
     }<br />
 }<br />
 int minn,minid;<br />
 void dfsmax(int x,int fa,int fasiz){<br />
     int maxn=fasiz-siz[x];<br />
     for(int i=head[x];i;i=e[i].next)<br />
     if(e[i].u!=fa&amp;&amp;vis[e[i].u]==){<br />
         dfsmax(e[i].u,x,fasiz);<br />
         maxn=max(maxn,siz[e[i].u]);<br />
     }<br />
     if(maxn&lt;minn) minn=maxn,minid=x;<br />
 }

 int makeroot(int x){<br />
     dfssiz(x,);<br />
     minn=INF; minid=;<br />
     dfsmax(x,,siz[x]);<br />
     return minid;<br />
 }

 struct trie{<br />
     int a[];<br />
 }a[M*]={};int root[M]={},use=;

 void add(int &amp;x,int zhi,int wei){<br />
     a[++use]=a[x]; x=use; int hh=;<br />
     if(wei&lt;) return;<br />
     if((&lt;&lt;wei)&amp;zhi) hh=;<br />
     add(a[x].a[hh],zhi,wei-);<br />
 }<br />
 int query(int x,int zhi,int wei){<br />
     if(wei&lt;||x==) return ;<br />
     int hh=,ans=;<br />
     if((&lt;&lt;wei)&amp;zhi) hh=;<br />
     if(!a[x].a[hh]) return query(a[x].a[hh^],zhi,wei-);<br />
     else return (&lt;&lt;wei)+query(a[x].a[hh],zhi,wei-);<br />
 }

 void dfsdis(int x,int fa,int hh,int cnt){<br />
     hh^=num[x];<br />
     add(root[cnt],hh,);<br />
     for(int i=head[x];i;i=e[i].next)<br />
     if(e[i].u!=fa&amp;&amp;vis[e[i].u]==){<br />
         dfsdis(e[i].u,x,hh,cnt);<br />
     }<br />
 }

 int ans=;

 void query(int x,int fa,int hh,int cnt){<br />
     hh^=num[x];<br />
     int now=query(root[cnt-],hh,);<br />
     ans=max(ans,now);<br />
     ans=max(ans,hh);<br />
     for(int i=head[x];i;i=e[i].next)<br />
     if(e[i].u!=fa&amp;&amp;vis[e[i].u]==){<br />
         query(e[i].u,x,hh,cnt);<br />
     }<br />
 }

 void calc(int x){<br />
     int cnt=;<br />
     for(int i=head[x];i;i=e[i].next)<br />
     if(vis[e[i].u]==){<br />
         cnt++; root[cnt]=root[cnt-];<br />
         dfsdis(e[i].u,x,,cnt);<br />
     }<br />
     cnt=;<br />
     for(int i=head[x];i;i=e[i].next)<br />
     if(vis[e[i].u]==){<br />
         cnt++;<br />
         ans=max(ans,num[x]);<br />
         query(e[i].u,x,num[x],cnt);<br />
     }<br />
     use=; memset(root,,(cnt+)&lt;&lt;);<br />
 }

 void dfs(int x){<br />
     x=makeroot(x); vis[x]=;<br />
     calc(x);<br />
     for(int i=head[x];i;i=e[i].next)<br />
     if(vis[e[i].u]==) dfs(e[i].u);<br />
 }

 int main(){<br />
 //    freopen("in.txt","r",stdin);<br />
 //    freopen("out.txt","w",stdout);<br />
     int n; scanf("%d",&amp;n);<br />
     for(int i=;i&lt;=n;i++) scanf("%d",num+i);<br />
     for(int i=;i&lt;n;i++){<br />
         int x,y; scanf("%d%d",&amp;x,&amp;y);<br />
         add(x,y); add(y,x);<br />
     }<br />
     dfs();<br />
     cout&lt;&lt;ans&lt;&lt;endl;<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7zlw19.html">第18讲&mdash;&mdash;ActiveX控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq15rn59.html">jsp一句话</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv7l7zq.html">开发环境python</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j61rwq.html">MVC - 18&period;缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/390xx2n9.html">mysql存储过程详解（入门）</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw72z38.html">认识C和内存管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1j43e9.html">0x03伪指令</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xeyoz8.html">Linux驱动开发cdev驱动分层设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x21lm8.html">开发人员应该知道的SEO</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zpxpn9.html">7、js使用正则表达式验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk15le8.html">Linux 播放网易云音乐&lpar;树莓派&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjpkyr9.html">C&plus;&plus;&sol;CLI</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw6ke78.html">android monitor 汉化 ddms</a>
		</li>
						<li><a href="https://www.batexi.com/a/963z54j9.html">Dbzoj&num;3188&period; &lbrack;Coci 2011&rsqb;Upit</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjrx268.html">错误结果保存示例 - 【jmeter】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9023dm3q.html">栈实现 C语言</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mj0rg08.html">Xposed模块开发基本方法记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl3ll39.html">20155338 2006-2007-2 《Java程序设计》第2周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mj1gor8.html">XML 增加属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pmpz479.html">spring java config 初探</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qverg7y9.html">使用JDBC连接MySql时出现：The server time zone value &amp;&num;39&semi;�&jcy;���׼ʱ��&amp;&num;39&semi; is unrecognized or represents more than one time zone&period; You must configure either the server or JDBC driver &lpar;via the serverTimezone configuration</a>
			</li>
						<li><a href="https://www.batexi.com/a/93p7oyg8.html">使用delphi 开发多层应用（二十二）使用kbmMW 的认证管理器</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pdgpnq.html">前端之JavaScript笔记3</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2yw208.html">跳出思维定势，改变交谈习惯zz</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvek1519.html">Mysql &amp;amp&semi; Hive 导入导出数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmlzdl9.html">BZOJ 1009 &lbrack;HNOI2008&rsqb;GT考试 &lpar;KMP &plus; 矩阵快速幂&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1vjr69.html">Java synchronized关键字的理解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1v4pk6q.html">20、docker swarm</a>
			</li>
						<li><a href="https://www.batexi.com/a/963d7mv9.html">java  把InputStream流写入到文件中</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rn7yyrq.html">Fig 7&period;2&period;4 &amp;amp&semi; Fig 7&period;3&period;2</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
